import os

class SwissKnife:

    modules = list()

    @classmethod
    def start(cls):
        cls.welcome()
        
        while True:
            cls.menu()
    
    @classmethod
    def read_modules(cls):
        from glob import glob
        dirlist = glob("*/")
        
        # Searches for directories.
        for directory in dirlist:
            file = directory + directory[0:-1]
            
            # If the directory has a file that we can run, run it.
            if(os.path.isfile(file + ".py")):
                cName = directory[0:-1].capitalize()
                mod = __import__(file.replace("\\","."),fromlist=[cName])
                obj = getattr(mod, cName)()
                cls.modules.append(obj);
        
        print("There are",len(cls.modules),"modules installed.");
    
    @classmethod
    def welcome(cls):
        print("===========================================")
        print("Welcome to Swiss Knife!")
        cls.display_cwd()
        cls.read_modules()
        print("===========================================")
        print()
    
    @classmethod
    def menu(cls):
    
        # Notify the user they are in the menu.
        print("Below are the modules available.")
        print("--------------------------------")
    
        l = len(cls.modules)
        for i in range(0, l):
            print(i+1,". ",cls.modules[i].display_name,sep="")
        
        print("E. Exit")
        print()
        
        # Retrieve the option and process it.
        opt = input("Select the module you want to run: ")
        
        if opt.lower() == "e":
            exit()
        else:
            opt = int(opt)
            if opt > 0 and opt <= l:
                cls.modules[opt - 1].run()
            else:
                print("Invalid option selected. Please try again.")
    
    @staticmethod
    def display_cwd():
        os.chdir(os.path.dirname(os.path.realpath(__file__)))
        print("The current working directory is: ",os.getcwd(),".",sep="")
        
    @staticmethod
    def datetime():
        from datetime import date
        print("The date today is ", date.today().strftime("%B %d, %Y"),".",sep="")


SwissKnife.start()